
#ifndef _KINE_H_
#define _KINE_H_

#include "mathutil.h"

#define JMax 4

typedef struct
{
	float px,py,pz;
	joint j;
	Matrix	m;
} kinechain;

typedef struct
{
	Matrix mat1;
	Matrix mat2;
	Matrix mat3;
	joint j;			/* Gelenk */
	float v[4];
	float tmp[4];
	float wink[3];

	GenMatrix gmat1;
	GenMatrix gmat2;
	GenMatrix gmat3;
	GenMatrix gmat4;
	GenMatrix gmat5;

	kinechain kc[JMax];

	float ex,ey,ez;	/* Endpunkt */

	Boolean check;

	float length;

	Int32 xoff;
	Int32 yoff;
	Int32 baselength;
	Int32 basex;
	Int32 basey;

	Int32 swidth;
	Int32 sheight; 

} world;

#endif /* _KINE_H_ */
