
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(int argc, char **argv)
{
	int i;
	double co = 2*M_PI/360.;
	FILE *fp = stdout;

	if(argc > 1)
	{
		fp = fopen(argv[1], "wb");
		if(fp == NULL)
		{
			perror("Failed to open file");
			return(EXIT_FAILURE);
		}
	}

	fprintf(fp, "#ifndef _SINCOS_H_\n");
	fprintf(fp, "#define _SINCOS_H_\n");

	fprintf(fp, "float SIN[] = \n");
	fprintf(fp, "\t{\n");
	for(i = 0; i < 360; i++)
	{
		if(i > 0)
			fprintf(fp, ",\n");
		fprintf(fp, "\t\t%f", (float)sin(i*co));
	}
	fprintf(fp, "\n\t};\n");

	fprintf(fp, "#endif //_SINCOS_H_\n");

	if(fp != stdout)
		fclose(fp);

	return(EXIT_SUCCESS);
}

