/*
 *
 *
 *	Include for Matrixoperations
 *	24.04.2001  Frank Pagels , Teil von MiniGL bernommen
 *  16.11.2001  Thomas Runge, Portierung auf PalmOS
 *
 */

#ifndef _MATRIX_H
#define _MATRIX_H

#define ABS(a)		(((a)<0) ? -(a) : (a))

#ifndef PI
	#ifdef M_PI
	#define PI M_PI
	#else
	#define PI 3.1415927
	#endif
#endif

typedef struct Matrix_t
{
		float v[16];
		Int32 flags;                  // Matrix flags
		struct Matrix_t *Inverse;   // optional inverse
} Matrix;


typedef struct
{
		Int32	rows;
		Int32	column;
		float	m[20][20];
		Int32	pvt_j[20];
		Int32	pvt_i[20];
} GenMatrix;


#define OF_11 0
#define OF_12 4
#define OF_13 8
#define OF_14 12

#define OF_21 1
#define OF_22 5
#define OF_23 9
#define OF_24 13

#define OF_31 2
#define OF_32 6
#define OF_33 10
#define OF_34 14

#define OF_41 3
#define OF_42 7
#define OF_43 11
#define OF_44 15

/* Struktur fr Gelenke */
typedef struct
{
	float	theta;
	Int32	d;
	Int32	a;
	Int32	a1;
	float	alpha;
} joint;


void MatMultGeneral(Matrix *pA, Matrix *pB, Matrix *pC);
void LoadIdentity(Matrix *pA);
void PrintMatrix(Matrix *pA);
void LoadMatrix(Matrix *pA, const float *v);
float Determinant(Matrix *pA);
void DoInvert(Matrix *pA, Matrix *pB);
void GetHartenberg(joint *j, Matrix *pA);
void MatMultPoint(Matrix *pA, float *v, float *tmp);
void InitGenMatrix(GenMatrix *A, Int32 row, Int32 column);
void DestroyGenMatrix(GenMatrix *A);
void GenPrintMatrix(GenMatrix *A);
void GenLoadMatrix(Matrix *pA, const float *v);
void GenMatTranspose(GenMatrix *A, GenMatrix *B);
void GenMatMultiply(GenMatrix *A, GenMatrix *B, GenMatrix *C);
void GenMatLoadIdentity(GenMatrix *A, float a);
void GenMatInvers(GenMatrix *A);
void GenMatCopy(GenMatrix *A,GenMatrix *B);
void GenMatPseudoInvers(GenMatrix *A,GenMatrix *B, GenMatrix *C);
void GenMatSub(GenMatrix *A,GenMatrix *B, GenMatrix *C);
void GenMatAdd(GenMatrix *A,GenMatrix *B, GenMatrix *C);




#endif
